NB. Create topo maps and GPS data to draw runs
NB. using J and image3 addon tools
NB. 

require '~addons/media/image3/prevare.ijs'
require '~addons/media/image3/view_m.ijs'
require '~addons/graphics/fvj3/dwin2.ijs'
pathd=:'c:/garmin/car_data/'    NB. path to forerunner data

NB. read_paletted pngs
raw_pal_read_png=: 3 : 0
sz=.*/ whd=.3{. pi=.png_get_info y
pc=.{:pi
if. 0=pc do. 'not a paletted image' return. end.
pa=.mema 3*pc
addr=.mema sz
a=.'png_to_mem + i *c i i *i' zjm y;addr;pa;(,0)
if. _1=>{.a do.
	memf&.> pa;addr
	_1 return. end.
pc=.{.>{:a
pal=.memr pa,0,(3*pc)
data=.memr addr,0,sz
memf&.> addr;pa
((pc,3)$a.i.pal);((1 0{whd)$data)
)

NB. mouse click gives pixel coords
viewimage_win_mbldown=: 3 : 0
smoutput |.2{.". sysdata
)

NB. $b=:dwin_image ''  NB. save the current window in image3 form
dwin_image=:3 : 0      NB. capture window as raster array
wd 'psel ',WIN_nam,';'
glsel 'g'
z=.(|.WIN_WH)$glqpixels 0 0,WIN_WH
z=.{&a.@:(256 256 256&#:)"1 z
z=.a.i.z
)

NB. coords 'caption' show_map map
show_map=:1 : 0
:
WIN_WH=:|.2{.$y
x dwin m
glpixels 0 0,WIN_WH,,256 256 256&#."_1 y
)

show_raw_map=:1 : 0
:
WIN_WH=:|.2{.$y
x dwin m
glpixels 0 0,WIN_WH,,(256 256 256&#.@(a.&i.))"_1 y
)

gis_to_win=:4 : '(1 _1*x)+"1 SC |."1 y'

NB. draw a line in pixel coords
draw_line=:3 : 0
(0 0 255;10 0) draw_line y
:
'color pen'=:x
wd 'psel ',WIN_nam
glrgb color
glpen pen
if. 0<#y do. gllines ,y end.
glpaint ''
$trek_z=:dwin_image ''
)

NB. draw the trek on map (gis coord)
draw_trek=:1 : 0
0 0 m draw_trek y
:
if. 'literal'-:datatype y=.>y do. y=.tp_in_lap y end.
m draw_line x gis_to_win y
)

NB. draw text in window coords
NB. dxdy font draw_win_text 'text' coords
draw_win_text=:2 : 0
0 0 m draw_win_text n y
:
wd 'psel ',WIN_nam
glfont m
for_k. i.#y do.
  gltextxy k{y
  gltext k{n
end.
glpaint '' 
$trek_z=:dwin_image ''
)

NB. draw text in gis coords
NB. dxdy font draw_text 'text' coords
draw_text=:2 : 0
0 0 m draw_text n y
:
wd 'psel ',WIN_nam
x m draw_win_text n x gis_to_win y
)


   