NB. lalo
NB. distance from latitude longitude script
NB. 

require 'trig'
require '~addons/media/image3/filter1.ijs'
require '~addons/media/image3/prevare.ijs'
NB. require 'c:\gis\ijs\get_laps.ijs'
NB. require pathi,'mk_md_adir.ijs'

NB. global parameters
lalo_a=:6378137
lalo_b=:6356752.3142
20j15":%lalo_f=:(lalo_a-lalo_b)%lalo_a

NB. x, y in degrees latitude and longitude, d in miles
lalo_to_d=: 4 : 0"1
'la1 lo1'=.x
'la2 lo2'=.y
L=.(2p1%360)*lo2-lo1
U1=._3 o.(1-lalo_f)*tan (2p1%360)*la1
U2=._3 o.(1-lalo_f)*tan (2p1%360)*la2
lam=.L
lamp=.2p1
while. 1e_12<|lam-lamp do.
  sins=.%:(*:(cos U2)*sin lam)+*:((cos U1)*sin U2)-(sin U1)*(cos U2)*cos lam  
  coss=.((sin U1)*sin U2)+(cos U1)*(cos U2)*cos lam
  s=._3 o. sins%coss
  sina=.(cos U1)*(cos U2)*(sin lam)%sins
  cos2a=. 1-*:sina
  cos2sm=.coss-2*(sin U1)*(sin U2)%cos2a
  C=.(lalo_f%16)*cos2a*4+lalo_f*4-3*cos2a
  lamp=.lam
  lam=.L+(1-C)*lalo_f*sina*s+C*sins*cos2sm+C*coss*_1+2**:cos2sm
end.
u2=.cos2a*((lalo_a^2)-lalo_b^2)%lalo_b^2
A=.1+(u2%16384)*4096+u2*_768+u2*320-175*u2
B=.(u2%1024)*256+u2*_128+u2*74-47*u2
ds=.B*sins*cos2sm+(B%4)*(coss*(_1+2**:cos2sm))-(B%6)*cos2sm*(_3+4**:sins)*_3+4**:cos2sm
0.0006214*lalo_b*A*s-ds
)

Filt1d=: 1 : 0
(# m)"_ +/@:(m&*)\ ]
)

len2=:+&.*:"1
diff=:}. - }:
NB. lmed=:<.@-:@# { /:~@,
NB. med=:1 : 'm"_ (<.-:m)&{@:(/:~)@,;._3 ]'

]wts=: (|.,}.)74 67 46 21 3 _5 _6 _3%320
locspen=: (+/ . *)&wts
spencer=: 15 locspen\ (7 # {.) , ] , 7 # {:

NB. fmt lalo within 50ft for gps trailhead
fmt_lalo=:'). ',~'Start Coordinates: (',;@('0.4,m<, ->0.4'&(8!:0))
fmt_ca=:' feet. ',~'Cumulative Ascent: ',[:": round&.(0.1&*)@:cum_alt

trek_d=:3 : 0
't0 la0 lo0 a0 d0'=.|:y
sla=.(1 gauss 3)Filt1d conext^:1 la0
slo=.(1 gauss 3)Filt1d conext^:1 lo0
stp=.sla,.slo
sa=.spencer a0*0.0006214
td=.(spencer diff sa) len2 (}.stp) lalo_to_d }:stp
+/\0,td
)

cum_alt=:3 : 0
3.2808399 *+/(#~0&<)diff(7 gauss 21)Filt1d y 
)

